/* global Bdf,$$,URLSearchParams,Pane */
/**
 * Objet global définissant l'espace de nom Multi
 * 
 * @namespace Multi
 */
var Multi = {};

Multi.ARGS = {
    authentificationSharingAllowed: false
};
Multi.waitingProcess = null;
Multi.fichothequeArray = {};
Multi.metadata = {};
Multi.defaultLogin = "";

Multi.ping = function (requestParameters, pingCallback) {
    var ajaxData = {};
    if (requestParameters) {
        Object.assign(ajaxData, requestParameters);
    }
    ajaxData.json = "ping";
    $.ajax({
        url: Bdf.URL + "multi-admin",
        method: "GET",
        dataType: "json",
        data: ajaxData,
        xhrFields: {
           withCredentials: true
        },
        success: function (data, textStatus) {
            if (pingCallback) {
                pingCallback(data);
            }
        }
    });
};

Multi.initPanes = function () {
    Pane.setLayoutVisible(true);
    $$("layout_list").html(Bdf.render("multi:list/pane", {withSphereActions: Multi.ARGS.authentificationSharingAllowed}));
    Bdf.runSerialFunctions(
       Multi.List.init
   );
   $$("listpane_button_newfichotheque").click(Multi.Overlay.showCreationForm);
   $$("listpane_button_initall").click(Multi.List.initAll);
   $$("listpane_button_listreload").click(Multi.List.reload);
   $$("listpane_button_personmanager").click(function () {
       if (!Bdf.confirmUnload()) {
            return false;
       }
       Pane.loadOrDestock("personmanager", Multi.PersonManager.load);
   });
   $$("listpane_button_metadata").click(function () {
        if (!Bdf.confirmUnload()) {
             return false;
        }
        Pane.loadOrDestock("metadata", function () {
            Multi.Metadata.init(Multi.Metadata.load);
        });
   });
};

Multi.testAuthentification = function (data) {
    if (!data.authentified) {
        $$("layout_main").html("");
        Multi.waitingProcess = Multi.initPanes;
        Multi.Overlay.showAuthentification(data);
        return false;
    } else {
        return true;
    }
};

Multi.getKey = function (category, value) {
    switch(category) {
        case "corpus":
            if (!value) {
                return "_ label.multi.fiches";
            } else {
                switch(value) {
                    case "none":
                        return "_ label.multi.fiches_none";
                    case "all":
                        return "_ label.multi.fiches_all";
                    default:
                        return "";
                }
            }
        case "thesaurus":
            if (!value) {
                return "_ label.multi.motcles";
            } else {
                switch(value) {
                    case "none":
                        return "_ label.multi.motcles_none";
                    case "all":
                        return "_ label.multi.motcles_all";
                    default:
                        return "";
                }
            }
        case "sphere":
            if (!value) {
                return "_ label.multi.redacteurs";
            } else {
                switch(value) {
                    case "none":
                        return "_ label.multi.redacteurs_none";
                    case "all":
                        return "_ label.multi.redacteurs_all";
                    default:
                        return "";
                }
            }
        case "album":
            if (!value) {
                return "_ label.multi.illustrations";
            } else {
                switch(value) {
                    case "none":
                        return "_ label.multi.illustrations_none";
                    case "all":
                        return "_ label.multi.illustrations_all";
                    case "selection":
                        return "_ label.multi.illustrations_selection";
                    default:
                        return "";
                }
            }
        case "addenda":
            if (!value) {
                return "_ label.multi.documents";
            } else {
                switch(value) {
                    case "none":
                        return "_ label.multi.documents_none";
                    case "all":
                        return "_ label.multi.documents_all";
                    case "selection":
                        return "_ label.multi.documents_selection";
                    default:
                        return "";
                }
            }
        default:
            return "";
    }
};

Bdf.addTemplateOptions({
    helpers: {
        isChecked: function (category, value) {
            switch(category) {
                case "corpus":
                    return (value === "none");
                case "album":
                case "addenda":
                    return (value === "selection");
                default:
                    return (value === "all");
            }
        },
        itemsLoc: function(category, value) {
            var key = Multi.getKey(category, value);
            if (key) {
                return Bdf.Loc.get(key);
            } else {
                return "?" + category + "/" + value + "?";
            }
        }
    }   
});

$(function(){
    if (URLSearchParams) {
        var searchParams = new URLSearchParams(window.location.search);
        if (searchParams.has("login")) {
            Multi.defaultLogin = searchParams.get("login");
        }
    }
    Bdf.initTemplates();
    Pane.initLayout({
        hiddenAtStart: true
    });
    Bdf.initBeforeUnload();
    Multi.ping({}, function (data) {
        if (!data.authentified) {
            Multi.waitingProcess = Multi.initPanes;
            Multi.Overlay.showAuthentification(data);
        } else {
            Multi.initPanes();
        }
     });

});
